<?php

/**
 * Magical post display Pro notice 
 */
class mgpFreeNotice
{


	function __construct()
	{

		add_action('admin_notices', [$this, 'admin_free_notice']);
		add_action('init', [$this, 'mgfree_notice_hide_options']);
	}

	/**
	 * Admin notice
	 *
	 * Warning when the site active free verision of magical post display
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 */
	public function admin_free_notice()
	{
		$mgpnpro_hide_date = get_option('mgpnpro_hide_date');
		if (!empty($mgpnpro_hide_date)) {
			$clickhide = round((time() - strtotime($mgpnpro_hide_date)) / 24 / 60 / 60);
			if ($clickhide < 25) {
				return;
			}
		}

		$mgposte_install_date = get_option('mgposte_install_date');
		if (!empty($mgposte_install_date)) {
			$install_day = round((time() - strtotime($mgposte_install_date)) / 24 / 60 / 60);
			if ($install_day < 2) {
				return;
			}
		}

		global $pagenow;
		if ($pagenow == 'themes.php') {
			return;
		}

		$message_head = esc_html__('🌟 Upgrade Magical Posts Pro Now! ✨', 'magical-posts-display');
		$message_body = esc_html__('Take your experience to the next level with Magical Posts Display Pro. Unleash a host of exciting possibilities as you upgrade, including access to a variety of premium widgets, elegant icons, captivating animations, and the ability to effortlessly filter posts by categories and tags. Dive into enhanced Video support, complete with the pro features you already know and love, along with a wealth of other fantastic additions that await your discovery.', 'magical-posts-display');
		$btn_text = esc_html__('Upgrade Pro', 'magical-posts-display');
		$btn_link = esc_url('https://wpthemespace.com/product/magical-posts-display-pro/?add-to-cart=8239');
		$btn2_text = esc_html__('No, Maybe Later', 'magical-posts-display');

		printf('<div style="padding:40px 20px" class="notice notice-warning mgp-pronotice"><strong><span style="font-weight:700;color:#17A15C;font-size:16px">%1$s</span></strong><p style=font-size:18px>%2$s</p> <a style="padding: 8px 25px"; font-size:16px target="_blank" href="%3$s" class="button button-primary">%4$s </a><a style="padding: 8px 25px;display:inline-block" href="#" style="margin-left:10px" class="mghideme">%5$s</a></div>', $message_head, $message_body, $btn_link, $btn_text, $btn2_text);
	}
	public function mgfree_notice_hide_options()
	{
		if (isset($_GET['mgfnotice']) && $_GET['mgfnotice'] == 1) {
			update_option('mgpnpro_hide_date', current_time('mysql'));
		}
		if (isset($_GET['mgrecnot']) && $_GET['mgrecnot'] == 1) {
			update_option('mgmain_hide_tinfo', 1);
		}
	}
}

new mgpFreeNotice();
